// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.collections;

import java.util.ConcurrentModificationException;
import java.util.NoSuchElementException;
import xl2.collections.node.SkipNode;

  /**
  * SkipSet iterator which returns SkipNode values.
  * @author Aaron Hansen
  * @see SkipSet
  * @version 1.0.0
  */
class SkipValueIterator extends SkipNodeIterator {

  // Constructors
  // ------------

  public SkipValueIterator() {}

  public SkipValueIterator(SkipSet set, SkipNode floor, SkipNode ceil) {
    super(set,floor,ceil);
    }


  // Public Methods
  // --------------

  public Object next() {
    if (NextNode == FirstExcludedNode)
      throw new NoSuchElementException();
    if ( (MySet.ModInt != ModInt) && (FailFastBoolean) )
      throw new ConcurrentModificationException();
    LastNode = NextNode;
    NextNode = NextNode.Next[0];
    return LastNode.getValue();
    }
    

  }//SkipValueIterator
