// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.collections;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;
import java.util.*;

  /**
  * The value collection of a SkipMap.
  * @author Aaron Hansen
  * @see SkipMap#values()
  * @version 1.0.0
  */
class ValueCollection extends AbstractCollection implements Externalizable {

  // Protected Fields
  // ----------------

  protected SkipMap TheMap = null;


  // Constructors
  // ------------

  public ValueCollection() {}

  public ValueCollection(SkipMap map) { 
    TheMap = map;
    }

  // Public Methods
  // --------------

  public void clear() {
    TheMap.clear();
    }

  public boolean contains(Object obj) {
    Iterator iterator = iterator();
    while (iterator.hasNext()) {
      if (iterator().next().equals(obj))
        return true;
      }
    return false;
    }

  public Iterator iterator() {
    EntrySet set = (EntrySet) TheMap.entrySet();
    return new SkipValueIterator(set.getSet(),set.floor(),set.ceiling());
    }

  public void readExternal(ObjectInput in) 
    throws ClassNotFoundException, IOException {
    TheMap = (SkipMap) in.readObject();
    }

  public boolean remove(Object obj) {
    Iterator iterator = iterator();
    while (iterator.hasNext()) {
      if (iterator().next().equals(obj)) {
        iterator.remove();
        return true;
        }
      }
    return false;
    }

  public int size() {
    return TheMap.size();
    }

  public void writeExternal(ObjectOutput out) throws IOException {
    out.writeObject(TheMap);
    }


  }//SkipMap
