// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.collections.node;

  /**
  * Node of a linked list.
  * @author Aaron Hansen
  * @version 1.0.0
  */
public class ListNode {

  // Public Fields
  // -------------

    /** Contents of the node. */
  public Object DataObject = null;

    /** Next node in the list. */
  public ListNode NextNode = null;


  // Constructor
  // -----------
  
    /**
    * Constructs an empty node.
    */
  public ListNode() {}


    /**
    * Constructs a node for the specified object.
    */
  public ListNode(Object object) {
    DataObject = object;
    }


  // Methods
  // -------

    /**
    * Contents of the node.
    */
  public Object getData() {
    return DataObject;
    }

    /**
    * Next node in the list.
    */
  public ListNode getNext() {
    return NextNode;
    }

    /**
    * For DListNode
    */
  public ListNode getPrev() {
    throw new IllegalStateException(
      "Attempt to use DListNode functionality in a ListNode");
    }

    /**
    * Contents of the node.
    */
  public void setData(Object object) {
    DataObject = object;
    }

    /**
    * Next node in the list.
    */
  public void setNext(ListNode node) {
    NextNode = node;
    }

    /**
    * For DListNode.
    */
  public void setPrev(ListNode node) {
    throw new IllegalStateException(
      "Attempt to use DListNode functionality in a ListNode");
    }


  }//class
