// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.collections.node;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

  /**
  * Extends SkipNode to add the value field.
  * @author Aaron Hansen
  * @versin 1.0.0
  */
public class SkipMapNode extends SkipNode {

  // Protected Fields
  // ----------------

  public Object Value = null;


  // Constructors
  // ------------

  public SkipMapNode(int levels, Object key) {
    super(levels,key);
    }

  public SkipMapNode(int levels, Object key, Object value) {
    super(levels,key);
    Value = value;
    }


  // Public Methods
  // --------------

  public Object getValue() {
    return Value;
    }

  public void readExternal(ObjectInput in) 
    throws ClassNotFoundException, IOException {
    super.readExternal(in);
    Value = in.readObject();
    }

  public Object setValue(Object obj) {
    Object old = Value;
    Value = obj;
    return old;
    }

  public void writeExternal(ObjectOutput out) throws IOException {
    super.writeExternal(out);
    out.writeObject(Value);
    }


  }//SkipMapNode
