import xl2.odb.*;

public class AddPerson {

    /**
    * Adds a person to the database.  There are two possible arguments: The
    * first (required) is the name of the addition, the second (optional) is 
    * the name of the parent.  The parent name is not required - in which 
    * case the new person set as the root of the database.
    */
  public static void main(String[] args) throws Exception {
    if ((args.length == 0) || (args.length > 2)) {
      System.out.println("Usage java AddPerson <new_name> [parent_name]");
      System.exit(0);
      }
    EncryptedDatabase db = new EncryptedDatabase();
    db.setPassword("mypassword");
    db.open("person_example",db.OPEN_READ_WRITE);
    db.newTransaction().begin();
    Person newBorn = new Person(args[0]);
    Person root = (Person) db.getRoot();
    if ((root == null) || (args.length == 1)){
      db.setRoot(newBorn);
      XL2TransactionMgr.commit();
      db.close();
      System.out.println("Root person set to " + args[0]);
      System.exit(0);
      }
    Person parent = root.find(args[1]);
    if (parent == null) {
      System.out.println("Person not found: " + args[1]);
      db.close();
      System.exit(0);
      }
    parent.addChild(newBorn);
    XL2TransactionMgr.commit();
    System.out.println(args[0] + " added as a child of " + args[1]);
    db.close();
    }


  }//FindPerson
