// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.odb;

  /**
  * A lock exists which prevents the database from being opened in the 
  * desired mode.
  * @author Aaron Hansen
  * @version 1.0.0
  */
public class DatabaseLockedException extends XL2Exception {

  // Protected Fields
  // ----------------

  protected String LockFileString = null;


  // Constructors
  // ------------

  public DatabaseLockedException(String lockFile) {
    super("Lock file exists: " + lockFile);
    LockFileString = lockFile;
    }


  // Public Methods
  // --------------

  public String getLockFile() {
    return LockFileString;
    }


  }//DatabaseLockedException
