// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.odb;

import java.util.*;
import xl2.collections.SkipSet;
import xl2.collections.node.SkipNode;

  /**
  * @author Aaron Hansen
  * @version 1.0.0
  */
class HandleSet extends SkipSet {

  // Constructors
  // ------------

  public HandleSet() {
    super();
    }


  // Public Methods
  // --------------

  public Handle get(long l) {
    int level = Levels.length;
    SkipNode current = null;
    while ((current == null) && (--level >= 0)) { //find starting level
      if ( (Levels[level] != null) 
        && (compareLong(Levels[level].Key,l) <= 0) ) {
        current = Levels[level];
        }
      }
    while (level >= 0) {  //now search
      while ( (current.Next[level] != null) 
        &&    (compareLong(current.Next[level].Key,l) <= 0) ) {
        current = current.Next[level]; //go forward in level
        }
      level--;
      }
    if ((current != null) && (compareLong(current.Key,l) == 0))
      return (Handle) current.Key;
    return null;
    }


  // Protected Methods
  // -----------------

  protected int compare(Object o1, Object o2) {
    return (int) (((Handle)o1).getHandle() - ((Handle)o2).getHandle());
    }

  protected long compareLong(Object o1, long l) {
    return ((Handle)o1).getHandle() - l;
    }


  }//class
