// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.odb;

import java.lang.ref.*;
import java.util.*;
import xl2.odb.util.ReferenceSet;
import xl2.odb.util.WeakHashReference;

  /**
  * Instances that were locked by aborted transactions.
  * @author Aaron Hansen
  * @version 1.0.0
  */
class InvalidMgr {

  // Protected Fields
  // ----------------

  protected static ReferenceQueue RefQueue = null;

  protected static ReferenceSet TheSet = null;


  // Public Methods
  // --------------

  public synchronized static void add(Object obj) {
    if (obj == null)
      return;
    if (TheSet == null) {
      RefQueue = new ReferenceQueue();
      TheSet = new ReferenceSet();
      }
    TheSet.add(new WeakHashReference(obj,RefQueue));
    }

  public static boolean contains(Object obj) {
    if (TheSet == null)
      return false;
    return TheSet.containsReferent(obj);
    }


  // Protected Methods
  // -----------------

  protected synchronized static void processQueue() {
    if (TheSet != null) {
      WeakHashReference ref = (WeakHashReference) RefQueue.poll();
      while (ref != null) {
        TheSet.remove(ref);
        ref = (WeakHashReference) RefQueue.poll();
        if ((TheSet.size() == 0) && (ref == null)) {
          RefQueue = null;
          TheSet = null;
          }
        }
      }
    }


  }//class
