// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.odb;

  /**
  * Thrown when attempting to lock objects whose state may differ from
  * there last committed state.  For example, instances that were WRITE locked
  * in a transaction that was aborted.
  * This only happens for previously serialized objects.
  * @author Aaron Hansen
  * @see XL2Transaction#lock(Object,int)
  * @version 1.0.0
  */
public class InvalidObjectException extends XL2Exception {

  // Protected Fields
  // ----------------

    /**
    * The object in question.
    */
  protected Object InvalidObjectException = null;


  // Constructors
  // ------------

  public InvalidObjectException(Object object) {
    InvalidObjectException = object;
    }


  // Public Methods
  // --------------

    /**
    * The object in question.
    */
  public Object getObject() {
    return InvalidObjectException;
    }


  }//InvalidObjectException
