// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.odb;

import java.lang.ref.*;
import java.util.*;
import xl2.odb.util.ReferenceSet;

  /**
  * All first class objects.
  * @author Aaron Hansen
  * @version 1.0.0
  */
class ReferentMgr {

  // Protected Fields
  // ----------------

  protected static ReferenceSet TheSet = new ReferenceSet();

  protected static ReferenceQueue RefQueue = new ReferenceQueue();

  protected static Object lock = new Object();


  // Public Methods
  // --------------

  public static void add(Referent referent) {
    synchronized (lock) {
      TheSet.add(referent);
      }
    }

  public static void evict(Referent referent) {
    synchronized (lock) {
      TheSet.remove(referent);
      }
    referent.getXL2Database().evict(referent);
    }

  public static Referent get(Object object) {
    if (object == null)
      return null;
    return (Referent) TheSet.referenceOf(object);
    }


  // Protected Methods
  // -----------------

    /*
    * Removes garbage collected referents.
    */
  protected static void processQueue() {
    Referent referent = (Referent) RefQueue.poll();
    int tries = 0;
    while ((referent = (Referent) RefQueue.poll()) != null) {
      try { 
        evict(referent); 
        } catch (Exception x) { Thread.yield(); }
      }
    }

  protected static ReferenceQueue refQueue() {
    return RefQueue;
    }


  }//ReferentMgr
