// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.odb;

import java.util.HashSet;
import java.util.Iterator;

  /**
  * Closes all open databases when the VM terminates.
  * @author Aaron Hansen
  * @since 1.3
  * @version 1.0.0
  */
class XL2ShutdownHook extends Thread {

  // Protected Fields
  // ----------------

  protected boolean ShutdownBoolean = false;
  
  protected HashSet TheHashSet = new HashSet();


  // Constructors
  // ------------

  public XL2ShutdownHook() {}


  // Public Methods
  // --------------

  public void addDatabase(XL2Database db) {
    if (ShutdownBoolean)
      throw new IllegalStateException("VM shutting down.");
    TheHashSet.add(db);
    }

  public void run() {
    ShutdownBoolean = true;
    Iterator iterator = TheHashSet.iterator();
    XL2Database db;
    while (iterator.hasNext()) {
      db = (XL2Database) iterator.next();
      try {
        if (db.getOpenMode() != db.NOT_OPEN)
          db.close();
        } catch (Exception x) {}
      }
    }

  public void removeDatabase(XL2Database db) {
    if (ShutdownBoolean)
      return; //don't modify or the iterator in run will throw an exception.
    TheHashSet.remove(db);
    }


  }//class
