// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.odb.util;

  /**
  * Adds order to synchronization.
  * @author Aaron Hansen
  * @version 1.0.0
  */
public class ExecutionQueue {

  // Protected Fields
  // ----------------

  protected Thread CurrentThread = null;

  protected ExecutionNode HeadNode = null;

  protected int SizeInt = 0;

  protected ExecutionNode TailNode = null;


  // Constructors
  // ------------

  public ExecutionQueue() {}


  // Public Methods
  // --------------

  public void enqueue() {
    if (Thread.currentThread() == CurrentThread)
      return;
    ExecutionNode node = null;
    synchronized (this) {
      SizeInt++;
      if (SizeInt == 1) {
        CurrentThread = Thread.currentThread();
        return;
        }
      node = new ExecutionNode();
      if (TailNode == null) {
        TailNode = node;
        HeadNode = node;
        }
      else {
        TailNode.NextNode = node;
        TailNode = node;
        }
      }
    synchronized (node) {
      try { 
        node.wait(); 
        CurrentThread = Thread.currentThread();
        } catch (Exception x) {}
      }
    }

  public void dequeue() {
    if (Thread.currentThread() == CurrentThread)
      CurrentThread = null;
    else
      return;
    ExecutionNode node = null;
    synchronized (this) {
      SizeInt--;
      if ((node = HeadNode) == null)
        return;
      if ((HeadNode = node.NextNode) == null)
        TailNode = null;
      }
    synchronized (node) {
      node.notify();
      }
    }

  public synchronized int size() {
    return SizeInt;
    }


  }//ExecutionQueue


class ExecutionNode {
  public ExecutionNode NextNode = null;
  }
