// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.transaction;

  /**
  * A transaction inadvertently aborted.
  * @author Aaron Hansen
  * @versin 1.0.0
  */
public class TransactionAbortedException extends TransactionException {

  // Protected Fields
  // ----------------

  protected Transaction TheTransaction = null;


  // Constructors
  // ------------

  public TransactionAbortedException(Transaction transaction, 
                                     String message) {
    super(message);
    TheTransaction = transaction;
    }

  public TransactionAbortedException(Transaction transaction, 
                                     Exception exception) {
    super(exception);
    TheTransaction = transaction;
    }


  // Public Methods
  // --------------

    /**
    * The transaction in question.
    */
  public Transaction getTransaction() {
    return TheTransaction;
    }


  }//TransactionAbortedException
