// Copyright (c) 2000 by Aaron Hansen. Use is subject to license terms.

package xl2.transaction;

  /**
  * A call was made when a transaction should have been closed.
  * @author Aaron Hansen
  * @see Transaction#isClosed()
  * @see Transaction#isOpen()
  * @version 1.0.0
  */
public class TransactionNotClosedException extends TransactionException {

  // Protected Fields
  // ----------------

  protected Transaction TheTransaction = null;


  // Constructors
  // ------------

  public TransactionNotClosedException(Transaction transaction) {
    TheTransaction = transaction;
    }

  public TransactionNotClosedException(Transaction transaction,
                                       String message) {
    super(message);
    TheTransaction = transaction;
    }


  // Public Methods
  // --------------

  public Transaction getTransaction() {
    return TheTransaction;
    }


  }//TransactionNotClosedException
