package xl2.util;

import java.io.InputStream;
import java.io.IOException;
import java.net.Socket;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.TimeZone;

  /**
  * Parses the time from time.nist.gov.
  */
public class AtomicTime {

  // Private Fields
  // --------------

  private static final String HostString = "time.nist.gov";

  private static final TimeZone UTC = TimeZone.getTimeZone("UTC");


  // Public Methods
  // --------------

    /**
    * Prints the local time to stdout.
    */
  public static void main(String[] args) throws Exception {
    System.out.println(atomicTime().getTime().toString());
    }

    /**
    * Returns the local time.
    */
  public static Calendar atomicTime() throws IOException {
    InputStream is = (new Socket(HostString,13)).getInputStream();
    StringBuffer buf = new StringBuffer(55);
    int ch;
    while ((ch = is.read()) >= 0)
      buf.append((char)ch);
    is.close();
    String time = buf.toString();
    GregorianCalendar cal = new GregorianCalendar(
      Integer.parseInt(time.substring(7,9)) + 2000, //year, yeah y2.1k bug.
      Integer.parseInt(time.substring(10,12)) - 1,  //month
      Integer.parseInt(time.substring(13,15)),      //day
      Integer.parseInt(time.substring(16,18)),      //hour
      Integer.parseInt(time.substring(19,21)),      //min
      Integer.parseInt(time.substring(22,24)));     //sec
    cal.setTimeZone(UTC);
    return cal;
    }


  }//AtomicTime
