// Copyright (c) 1999-2000 by Wishclick, Inc.  All rights reserved.
package xl2.util;

import java.io.PrintStream;
import java.io.PrintWriter;

  /**
  * RuntimeException most likely wrapping some other exception and 
  * delegates all method calls to the inner exception.
  */
public class NestedException extends RuntimeException {

  // Protected Fields
  // ----------------

  protected Exception TheException = null;


  // Constructors
  // ------------

  public NestedException() {}

  public NestedException(Exception x) {
    super(x.getMessage());
    TheException = x;
    }

  public NestedException(String message) {
    super(message);
    }


  // Public Methods
  // --------------

    /**
    * The inner exception.
    */
  public Exception getException() {
    return TheException;
    }

  public String getLocalizedMessage() {
    if (TheException != null)
      return TheException.getLocalizedMessage();
    else
      return super.getLocalizedMessage();
    }

  public String getMessage() {
    if (TheException != null)
      return TheException.getMessage();
    else
      return super.getMessage();
    }

  public void printStackTrace() {
    if (TheException != null)
      TheException.printStackTrace();
    else
      super.printStackTrace();
    }

  public void printStackTrace(PrintStream s) {
    if (TheException != null)
      TheException.printStackTrace(s);
    else
      super.printStackTrace();
    }

  public void printStackTrace(PrintWriter s) {
    if (TheException != null)
      TheException.printStackTrace(s);
    else
      super.printStackTrace();
    }

  public String toString() {
    if (TheException != null)
      return TheException.toString();
    else
      return super.toString();
    }


  }//class NestedException
